using System;
using System.Collections.Generic;
using System.Text;

namespace NoJavaLibrary.Game.Scripts
{
    delegate void ScriptEventHandler(Script sendScript);

    /// <summary>
    /// XNvg̈Đ܂œ͂NX
    /// </summary>
    class ScriptSender
    {
        #region ϐ
        IGameObject owner;
        IScriptReader reader;
        #endregion

        #region Cxg
        /// <summary>
        /// q̃XNvg𑗂Ƃ
        /// </summary>
        public event ScriptEventHandler ChildScriptSend;
        /// <summary>
        /// owner̃XNvg𑗂Ƃ
        /// </summary>
        public event ScriptEventHandler OwnerScriptSend;
        /// <summary>
        /// łƂ
        /// </summary>
        public event DiscreatingEventHandler Discreating;
        #endregion

        public ScriptSender(IScriptReader reader, IGameObject owner)
        {
            this.owner = owner;
            this.reader = reader;
            RegisterReaderEventHandler();
        }

        #region ֐
        #region Cxgnho^
        /// <summary>
        /// Readerɑ΂ăCxgnho^
        /// </summary>
        void RegisterReaderEventHandler()
        {
            reader.ScriptCatch += new ScriptEventHandler(reader_ScriptCatch);
            reader.Discreating += new DiscreatingEventHandler(reader_Discreating);
        }

        /// <summary>
        /// Readerɑ΂ẴCxgnh폜
        /// </summary>
        void DisregisterReaderEventHandler()
        {
            reader.ScriptCatch += new ScriptEventHandler(reader_ScriptCatch);
            reader.Discreating -= new DiscreatingEventHandler(reader_Discreating);
        }
        #endregion

        /// <summary>
        /// ł
        /// </summary>
        void Discreate()
        {
            Discreating();
            DisregisterReaderEventHandler();
        }
        #endregion

        #region Cxgnh
        void reader_ScriptCatch(Script sendScript)
        {
            // owner邢͎qłȂƂ
            if (sendScript.Name[sendScript.Count] != owner.Name)
            {
                return;
            }

            // XNvgownerĂƂ
            if (sendScript.Count == sendScript.Name.Length - 1)
            {
                OwnerScriptSend(sendScript);
                return;
            }

            sendScript.Count++;
            ChildScriptSend(sendScript);

            // XNvgǂ󂯎ĂȂƂ
            if (sendScript.IsGet)
            {
#warning "[XNvgɃG[]ďo悤ɎȂKv"
                sendScript.IsGet = true;
            }
        }

        void reader_Discreating()
        {
            Discreate();
        }
        #endregion
    }
}
